//
//  GSToolView.m
//  wejointoo
//
//  Created by ijointoo on 2017/8/10.
//  Copyright © 2017年 demo. All rights reserved.
//

#import "GSToolView.h"
#import "UIView+JKPicker.h"

#define kScreenWidth [UIScreen mainScreen].bounds.size.width
#define kScreenHeight [UIScreen mainScreen].bounds.size.height

@interface GSToolView ()

@property (nonatomic,assign) CGFloat Kpadding;

@property (nonatomic,strong) NSMutableArray * titleLabelSizeArray;

@property (nonatomic,weak) UIScrollView * backScrollView;

@property (nonatomic,getter = isLayouted) BOOL layouted;

@property (nonatomic,weak) UIView * boderView;

@property (nonatomic,assign) NSInteger currentIndex;

@property (nonatomic,weak) UILabel * selectedLabel;

@end

static const CGFloat KminiPadding = 20;
static const CGFloat KboderViewHeight = 3;

@implementation GSToolView

+ (GSToolView *)gsToolViewWithTitleArray:(NSArray *)titiles{
    GSToolView * toolView = [[GSToolView alloc]init];
    toolView.titileArray = titiles;
    return toolView;
}

- (void)layoutSubviews{
    
    [super layoutSubviews];
    
    if (!self.isLayouted) {
        
        [self setUpPadding];
        
        [self setUpTitleLabels];
        
        self.layouted = YES;
    }
    
    
}

- (void)setUpPadding{
    
    CGFloat maxWidth = 0.0;
    self.currentIndex = 0;
    for (NSString * titleString in self.titileArray) {
        
        CGSize currentButtonSize = [titleString boundingRectWithSize:CGSizeMake(CGFLOAT_MAX, self.JKheight) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:self.highLightFontSize]} context:nil].size;
        maxWidth  = maxWidth + currentButtonSize.width;
        [self.titleLabelSizeArray addObject:[NSValue valueWithCGSize:currentButtonSize]];
    }
    
    UIScrollView * backScrollView = [[UIScrollView alloc]init];
    backScrollView.frame =  self.bounds;
    self.backScrollView = backScrollView;
    [self addSubview:backScrollView];
    CGFloat currentMaxWidth = (self.titileArray.count + 1) * KminiPadding + maxWidth;
    backScrollView.contentSize = CGSizeMake(currentMaxWidth, self.bounds.size.height);
    backScrollView.showsHorizontalScrollIndicator = NO;
    backScrollView.backgroundColor = [UIColor whiteColor];
    
    if (currentMaxWidth < kScreenWidth) {
        backScrollView.contentSize = CGSizeMake(self.bounds.size.width, self.bounds.size.height);
        self.Kpadding = (kScreenWidth - maxWidth)/(self.titileArray.count + 1);
    }else{
        self.Kpadding = KminiPadding;
    }
}


- (void)setUpTitleLabels{
    
    CGFloat lastLabelMaxX = 0.0;
    for (int index = 0; index < self.titileArray.count; index++) {
        UILabel * titlelabel = [[UILabel alloc]init];
        titlelabel.textAlignment = NSTextAlignmentCenter;
        titlelabel.text = self.titileArray[index];
        CGSize labelSize = [self.titleLabelSizeArray[index] CGSizeValue];
        titlelabel.tag = index;
        titlelabel.font = [UIFont systemFontOfSize:self.commonfontSize];
        titlelabel.userInteractionEnabled = YES;
        CGFloat labelX = self.Kpadding + lastLabelMaxX;
        CGFloat labelY = 0;
        titlelabel.frame = CGRectMake(labelX, labelY, labelSize.width, self.JKheight);
        lastLabelMaxX = CGRectGetMaxX(titlelabel.frame);
        
        UITapGestureRecognizer * tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(clickTitle:)];
        [titlelabel addGestureRecognizer:tap];
        
        [self.backScrollView addSubview:titlelabel];
        
        if (index == 0) {
            
            self.selectedLabel = titlelabel;
            self.selectedLabel.textColor = self.tintColor;
            self.selectedLabel.font = [UIFont systemFontOfSize:self.highLightFontSize];
        }
    }
    
    UIView * boderView = [[UIView alloc]init];
    boderView.backgroundColor = self.tintColor;
    boderView.frame = CGRectMake(self.selectedLabel.frame.origin.x, self.JKheight - KboderViewHeight, self.selectedLabel.frame.size.width, KboderViewHeight);
    [self.backScrollView addSubview:boderView];
    self.boderView = boderView;
}

- (void)clickTitle:(UITapGestureRecognizer *)tap{
    
    UILabel * currentLabel = (UILabel *)tap.view;
    CGFloat delta = currentLabel.tag - self.currentIndex;
    self.currentIndex = currentLabel.tag;
    [self p_scrollToTitleLabel:currentLabel];
    BOOL animate;
    if(fabs(delta) > 1){
        animate = NO;
    }else{
        animate = YES;
    }
    
    if ([self.zhnDelegate respondsToSelector:@selector(gsToolViewSelectedIndex:animate:)]) {
        [self.zhnDelegate gsToolViewSelectedIndex:currentLabel.tag animate:animate];
    }
    
}

- (void)p_scrollToTitleLabel:(UILabel *)titleLabel{
    
    self.selectedLabel.textColor = [UIColor blackColor];
    self.selectedLabel.font = [UIFont systemFontOfSize:self.commonfontSize];
    
    UILabel * tapedLabel = titleLabel;
    CGFloat currentDelta = tapedLabel.frame.origin.x - kScreenWidth / 2;
    self.selectedLabel = tapedLabel;
    
    [self.backScrollView scrollRectToVisible:CGRectMake(currentDelta + tapedLabel.frame.size.width/2, 0, kScreenWidth, self.JKheight) animated:YES];
    
    [UIView animateWithDuration:0.3 animations:^{
        self.selectedLabel.font = [UIFont systemFontOfSize:self.highLightFontSize];
        self.selectedLabel.textColor = self.tintColor;
        self.boderView.frame = CGRectMake(tapedLabel.frame.origin.x, self.JKheight - KboderViewHeight, tapedLabel.frame.size.width, KboderViewHeight);
    }];
    
}

#pragma  mark -
- (void)gsPageScrollViewToindex:(NSInteger)index{
    
    UILabel * currentLabel = self.backScrollView.subviews[index+1];
    self.currentIndex = currentLabel.tag;
    [self p_scrollToTitleLabel:currentLabel];
}
- (void)gsScrollHorizontalToIndex:(NSInteger)index{
    UILabel * currentLabel = self.backScrollView.subviews[index+1];
    self.currentIndex = currentLabel.tag;
    [self p_scrollToTitleLabel:currentLabel];
}
- (NSMutableArray *)titleLabelSizeArray{
    if (_titleLabelSizeArray == nil) {
        _titleLabelSizeArray = [NSMutableArray array];
    }
    return _titleLabelSizeArray;
}


/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
